! Aufgabe:
! Gegeben sei ein Labyrinth und eine Startposition darin. Nun soll ein Ausweg
! gefunden werden, also ein Pfad von der Startposition zum Rand des Labyrinthes.
! Es soll NUR EINE Lösung berechnet werden (egal, ob es "bessere" gibt). Diese 
! ist graphisch auszugeben (dazu gibt es schon die Funktion printLabyrinth).
! Das Labyrinth ist als 2D-Array gespeichert, wobei "X" eine Wand ist, "." eine
! bereits besuchte Stelle und " " eine freie Stelle (Weg, keine Wand).

program main
    implicit none
    ! Beispiel-Labyrinth
    character, dimension(10,10) :: labyrinth = reshape( [ &
        &"X","X","X","X","X","X","X","X","X","X", &
        &"X"," "," "," "," ","X"," "," "," "," ", &
        &"X","X","X","X"," ","X","X"," ","X","X", &
        &"X"," "," "," "," ","X","X"," ","X","X", &
        &"X"," ","X","X"," ","X","X"," "," ","X", &
        &"X"," "," ","X"," ","X","X"," ","X","X", &
        &"X","X","X","X"," "," "," "," "," ","X", &
        &"X","X"," ","X"," ","X"," ","X"," ","X", &
        &"X"," "," "," "," ","X"," ","X"," ","X", &
        &"X","X","X","X","X","X","X","X","X","X" &
    & ], [10,10], order=[2,1]) ! So gibt man in Fortran 2D-Arrays an ;)
    logical :: end


    call backtracking(labyrinth,2,2, end)! Labyrinth lösen mit Startposition (2,2).
    !                                    ! Also von der linken, oberen Ecke aus.

contains
    recursive subroutine backtracking(labyrinth, x, y, end)
        character, dimension(:,:), intent(inout) :: labyrinth ! 2D-Array aus "X", " ", "."
        integer, intent(in) :: x,y ! Position im Labyrinth
        logical, intent(out) :: end ! Es soll nur eine Lösung gefunden werden.
        ! Dazu wird die Variable "end" jedem rekursiven Aufruf mitgegeben. Sobald der
        ! Rand erreicht (und die Lösung angezeigt) wurde, wird "end" auf true gesetzt.
        ! Das ist hilfreich, um weitere rekursive Abstiege zu verhindern.
        
        ! geg. sind weitere Variablen hilfreich


        ! Unten stehen Hilfestellungen zum Vorgehen. Versucht es aber gern ohne diese.
        
    end subroutine backtracking
    
    subroutine printLabyrinth(labyrinth)
        character, dimension(:,:), intent(inout) :: labyrinth
        integer :: i
        do i=1,size(labyrinth,1)
            write(*,*) expanded(labyrinth(i,:),up=.true.)
            write(*,*) expanded(labyrinth(i,:),up=.false.)
        end do
    end subroutine printLabyrinth
    elemental function expanded(char, up)
        character, intent(in) :: char
        character(3) :: expanded
        logical, intent(in) :: up
        if ( char=="." ) then
            if ( up ) then
                expanded = " . "
            else 
                expanded = "   "
            end if
        else 
            expanded = char//char//char
        end if
    end function expanded
end program main







!       |
!       V








! Hilfestellung zum Vorgehen beim backtracking:
        !  - Falls die Position nicht frei (sondern eine Wand oder bereits besucht) ist,
        !    ist nichts zu tun (dort führt kein Weg lang)
        !  - Falls die Position frei und am Rand ist, ist die Lösung gefunden
        !  - Falls die Position keine Wand und nicht am Rand ist, markieren wir sie
        !    als "bereits besucht" und betrachten die vier benachbarten Positionen.
        !    Anschließend markieren wir sie wieder als frei.