PROGRAM taschenrechner2
	IMPLICIT NONE

	REAL :: h, x, y, z
	INTEGER :: n, k 
	CHARACTER :: c

	DO
		WRITE(*,*)
		WRITE(*,*) 'Please enter calculation operation '
		WRITE(*,*) '(+,-,*,:, "c" for cirlce area, "p" for prism, "f" for factorial, "t" for triangular number, '
		WRITE(*,*) '"b" for binomial coefficient, "q" for quit):'
		READ(*,*) c
		WRITE(*,*)

		IF(c == '+'.OR.c=='-'.OR.c=='*'.OR.c==':') THEN
			WRITE(*,*) 'Please enter real values for x and y:'
			READ(*,*) x, y
		ELSE IF(c == 'c') THEN
			WRITE(*,*) 'Please enter real value for diameter:'
			READ(*,*) x
		ELSE IF(c == 'p') THEN
			WRITE(*,*) 'Please enter real values for a, b and height h:'
			READ(*,*) x, y, h
		ELSE IF(c=='f') THEN 
			WRITE(*,*) 'Please enter integer value for n!'
			READ(*,*) n 
		ELSE IF(c=='t') THEN 
			WRITE(*,*) 'Please enter integer value for n for the triangular number'
			READ(*,*) n
		ELSE IF(c == 'b') THEN
			WRITE(*,*) 'Please enter real values for n and k for the binomial coefficent:'
			READ(*,*) n,k 
		ELSE IF(c == 'q') THEN
			EXIT
		ELSE
			WRITE(*,*) 'No permitted calculation operation entered.'
		END IF

		SELECT CASE(c)
			CASE('+')
				z = x + y
				WRITE(*,*) x ,'+', y, '=', z
			CASE('-')
				z = x - y
				WRITE(*,*) x ,'-', y, '=', z
			CASE('*')
				z = x*y
				WRITE(*,*) x ,'*', y, '=', z
			CASE(':')
				IF (y/=0) THEN
					z = x/y
					WRITE(*,*) x ,':', y, '=', z
				ELSE
					WRITE(*,*) 'Dividing by zero is not permitted.'
				END IF
			CASE('c')
				WRITE(*,*) 'The area is', area(x)
			CASE('p')
				CALL cuboid(x, y, h)
			CASE('f')
				WRITE(*,*) 'The factorial (iterative) is', it_fak(n)
				WRITE(*,*) 'The factorial (recursive) is', rek_fak(n)
			CASE('t')
				WRITE(*,*) 'The triangular number (iterative) is', it_dreieck(n)
				WRITE(*,*) 'The triangular number (recursive) is', rek_dreieck(n)
			CASE('b')
				WRITE(*,*) 'The binomial coefficient (iterative) is', it_bin(n,k)
				WRITE(*,*) 'The binomial coefficient (recursive) is', rek_bin(n,k)
			CASE DEFAULT
				EXIT
		END SELECT
	END DO

CONTAINS

		FUNCTION area(d)
			REAL, INTENT(IN) :: d
			REAL :: area, pi = 3.14159265359
			area = pi*d**2/4								!wegen d = 2*r (r Radius)
		END FUNCTION

		SUBROUTINE cuboid(a, b, h)
				REAL, INTENT(IN) :: a, b, h
				WRITE(*,*) 'Volume of the cuboid:', a*b*h
				WRITE(*,*) 'Area of the cuboid:', 2*(a*b + a*h + b*h)
		END SUBROUTINE
		
		FUNCTION it_fak(n) 
			INTEGER, INTENT(IN) :: n 
			INTEGER :: it_fak, i 
			it_fak = 1
			DO i=1,n 
				it_fak = it_fak*i
			END DO
		END FUNCTION
	
		FUNCTION it_dreieck(n)
			INTEGER, INTENT(IN) :: n 
			INTEGER :: it_dreieck, i 
			it_dreieck = 0
			DO i=1,n 
				it_dreieck = it_dreieck + i 
			END DO 
		END FUNCTION
		
		FUNCTION it_bin(n,k)
			INTEGER, INTENT(IN) :: n, k 
			INTEGER :: it_bin
			it_bin = it_fak(n) / (it_fak(k)*it_fak(n-k))
		END FUNCTION
		
		RECURSIVE FUNCTION rek_fak(n) RESULT(res)
			INTEGER, INTENT(IN) :: 	n
			INTEGER :: res
			IF(n==0) THEN
				res = 1
			ELSE 
				res = rek_fak(n-1)*n 
			END IF
		END FUNCTION
	
		RECURSIVE FUNCTION 	rek_dreieck(n) RESULT(res)
			INTEGER, INTENT(IN) :: n 
			INTEGER :: res 
			IF(n==0) THEN 
				res = 0 
			ELSE 
				res = rek_dreieck(n-1) + n 
			END IF 
		END FUNCTION
	
		RECURSIVE FUNCTION rek_bin(n,k) RESULT(res)
			INTEGER, INTENT(IN) :: n, k 
			INTEGER :: res 
			IF(k>n) THEN 
				res = 0
			ELSE IF(n==k .OR. k==0) THEN 
				res = 1
			ELSE 
				res = rek_bin(n-1,k-1) + rek_bin(n-1,k) 
			END IF 
		END FUNCTION

END PROGRAM taschenrechner2
