!Generelle Infos 
    ! Name1_Name2.f95 
    ! .f95 Datei, keine Exe
    ! wenn möglich, alle Aufgaben in eine Datei
    ! bei mehreren Abgaben die alten löschen
    ! Antworten auf Fragen als Kommentar in der gleichen Datei
    ! Style (übersichtlicher Code [keine Umlaute]) auch nicht zu viele Freizeilen
    ! Groß- und Kleinschreibung nicht durcheinanderbringen
    ! Kommentare nicht vergessen !!
    ! möglichst effizient
    ! testen nicht vergessen -> Helpdesk

module module_vorlage
    implicit none
    private
    public:: fak_iter,fak_rek, Planet, operator(.and.),add

    TYPE::  Planet
            INTEGER:: anzMonde
            logical:: bewohnbar
            !type(xy):: Gesteinsarten
    END TYPE  Planet

    TYPE(Planet), PARAMETER :: Erde = Planet(1,.true.)

    interface operator (.and.)
        module procedure und
    end interface

    


    contains
    !Funktionen
        function fak_iter(j) !Berechnung Fakultät iterativ 
            integer,intent(in)::j
            integer::fak_iter,k

            fak_iter=1

            do k=2,j
                fak_iter=k*fak_iter
            end do
        end function fak_iter

        recursive function fak_rek(j) result(erg) !Berechnung Fakultät rekursiv 
            integer,intent(in)::j
            integer::erg

            if(j==0)then
                erg=1
            else
                erg=j*fak_rek(j-1)
            end if
        end function fak_rek

        function und(a,b)
            type(planet), intent(in)::a,b
            logical::und
            und=.false.
            if(a%bewohnbar.and.b%bewohnbar)und=.true.
            !besser: und = a%bewohnbar.and.b%bewohnbar
        endfunction und

    !Subroutine

        subroutine add(a,b)
            real,intent(in)::b
            real,intent(inout)::a
            a=a+b
        endsubroutine
    
end module module_vorlage



program Vorlage
    use module_vorlage         
    implicit none

    real:: Gleitkommazahlen,r
    character(len=19):: Wort
    integer::n,i, ios,fehler
    integer, parameter :: real_kind=selected_real_kind(P=6, R=37)
    real(kind=real_kind)::x  
    !struktorierter Datentyp
    type(Planet):: Erde, Saturn
    ! Array declarationen
    Integer, dimension (:,:), allocatable::A
    Integer, dimension(4)::B,C!=(/0,0,0,0/) für Parameter
    integer,dimension(3,3)::D
    character(20),dimension(2,2)::Inhalt

    write(*,*) "Geben Sie die Anzahl der Schleifendurchlaeufe ein"
    read(*,*) n

!If und do-Schleifen

    if(n==1)then
        write(*,*)"wie langweilig bist du denn?"
    elseif(n>10)then !optional
        write(*,*)"Zumutung!"
    else             !optional
        write(*,*)"gute Wahl"
    endif

   
    main: do i=1,n
        write(*,*) i
        if(i==10)then   !if(i==10)exit
            write(*,*)"Schleife wurde abgebrochen"
            exit main
        endif
    enddo main

    i=1
    do while (i<10)
        i=i+1
        write(*,*) i
    enddo

! Aufgabenblatt 3

    write(*,*)"e^",r,"=",exp(r) !r muss real sein
    write(*,*)"e^",n,"=",exp(real(n)) !n kann durch den Befehl real(.) zu einer real-Variable gemacht werden    

! Module (am Anfang use module nicht vergessen!)
    do i = 1, 10
        write(*,*)fak_iter(i)
    end do
    do i = 1, 10
        write(*,*)fak_rek(i)
    end do
    
! Aufgabenblatt 4
    !Tipp: hohen real_kind Wert verwenden (z.B. 16)
    write(*,*) spacing(r) ! liefert den kleinsten Abstand zu einer darstellbaren Gleitkommazahl
    Write(*,*) sqrt(2._8) ! Wurzel(2) Der Punkt signalisiert, dass die 2 hier als real angesehen werden soll. Fortran nimmt keine Wurzeln aus Integer

! subroutine aufrufen
    r=5
    call add(r,5.)
    write(*,*)r

!Datentypen
    Saturn%bewohnbar= .false.
    Saturn%anzMonde= 82
    write(*,*) Saturn
    write(*,*) Saturn%anzMonde, Saturn%bewohnbar

!Aufgabenblatt 5
    !ivalmod
    !im HP gleiche Genauigkeit wie im Modul verwenden (pr)
    !Erstellen neuer Intervalle mittels ival(a,b)
    !Ausgabe von Intervall I mittels call put(I)

!Aufgabenblatt 6
    allocate(A(2,2))
    B(1)=9
    B(2)=5
    C=(/1,2,3,4/)
    D(2,3) = 5 !zweite Zeile, Spalte 3 
    write(*,*) size(C) !gibt anzahl der Elemente der ersten Dimension (size(D,2)) gibt Anzahl der Elemente der 2. Dimension -> nützlich für Schleifen

    deallocate(A)

!Aufgabenblatt 7

    !Lesen/Schreiben von Dateien
    open(unit = 30, file = "name.txt",status="new",action= 'write',iostat=ios)  !Datei schreiben
            if(ios/=0)Write(*,*)"Fehler beim Oeffnen der Datei" !fehler und ios müssen als Integer declariert werden
            write(30,*)"Hello World", "dlroW olleH"
            write(30,*)"olleH lordW", "Wdrol Hello"
            write(30,*)42
    close(30)
    
    open(unit = 30, file = "name.txt",status="old",action= 'read',iostat=ios)  !Datei lesen
        if(ios/=0)Write(*,*)"Fehler beim Oeffnen der Datei"
        !Zeilenweise
        do i=1,2
                read(30, *, iostat=ios) Inhalt(i,:)
                if(ios/=0)Write(*,*) "Fehler beim lesen" !exit
                write(*,*)Inhalt(i,:)
        enddo
        
        !Ein Einzelelement
        read(30, *, iostat=ios) i
        if(ios/=0)Write(*,*) "Fehler beim lesen"
        Write(*,*)i
    close(30)

    ! für Aufgabe 17 eignet sich der intrinsische Befehl transpose(A), welcher die transponierte von A gibt

end program Vorlage
